//
// Created by Alvin on 2018/5/8.
//

#ifndef LIBNETSDK_LIBNETSDK_H
#define LIBNETSDK_LIBNETSDK_H
#include "sdk_define.h"

typedef struct _IPC_ENTRY_AJ
{
	char				ipc_sn[32];
	char				platform_id[32];
	char				p2p_id[128];
	char				deviceType[32];
	char				version[128];
	UserConfig			userCfg;
	StreamAccessConfig	streamCfg;
	LANConfig			lanCfg;
	int					p2pStatus;
	int					runnedtime;
	int					bChanged;
}IPC_ENTRY_AJ;

//回调函数原型
typedef long(CALLBACK *SearchIPCCallBack)(long nEventCode, long index, IPC_ENTRY_AJ *pResponse, void *pUser);
typedef long(CALLBACK *StatusEventCallBack)(long lUserID, long nStateCode, char *pResponse, void *pUser);
typedef long(CALLBACK *AUXResponseCallBack)(long lUserID, long nType, char *pResponse, void *pUser);
typedef long(CALLBACK *fRealDataCallBack)(long lRealHandle, long dwDataType, unsigned char *pBuffer, long dwBufSize, LPFRAME_EXTDATA  pExtData);
typedef	long(CALLBACK* fCaptureAudioCallBack)(unsigned char* pData, long dwBufSize, void* pUser);
typedef long(CALLBACK *SerialDataCallBack) (long lUserID, unsigned char *pRecvDataBuffer, long dwBufSize, void *pUser);
//sdk初始化和清理
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_Init();
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_Cleanup();
//sdk设置回调
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_SetSearchStatusCallBack(SearchIPCCallBack fcallBack, void * pUser);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_SetStatusEventCallBack(StatusEventCallBack fStatusEventCallBack, void * pUser);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_SetRealPlayStatusEventCallBack(StatusEventCallBack fStatusEventCallBack, void * pUser);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_SetAUXResponseCallBack(AUXResponseCallBack fAUXCallBack, void * pUser);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_SetReplayDataCallBack(fRealDataCallBack cbReplayDataCallBack, void * dwUser);

//设备搜索
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_StartSearchIPC();
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_StopSearchIPC();
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_SendSearchMsg();
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GetSearchIPCCount();
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GetIPCInfo(long index, IPC_ENTRY_AJ * pIPCInfo);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_ModifyIPC(long index, IPC_ENTRY_AJ * pIPCInfo);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GetOneIPAddress(char * strResult, int nSize);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GetNetworkParam(unsigned long nParamIndex, char * strResult, int nSize);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_RestoreIPC(long index, IPC_ENTRY_AJ * pIPCInfo);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_RestoreIPC(char*sDevSn);
//设备登录
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_SetAutoReconnect(long lUserID, int bAutoReconnect);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_Reconnect(long lUserID);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_Login(char *sDVRIP, long nPort, char *sUserName, char *sPassword);
LIB_NETSDK_API long __stdcall AJ_NETSDK_Server_Login(char * sDVRIP, long nPort, char * sUserName, char * sPassword, char *sUserIdentity);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_Logout(long lUserID);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_LogoutAll();

//设备设备视频流请求
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_RealPlay(int nVideoChannle, char * pserverip, char *user, char *pass, int nLinkMode, int nVideoPort, fRealDataCallBack cbRealDataCallBack, void* pUser);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_RealPlay(char * rtspurl, char *user, char *pass, int nLinkMode, fRealDataCallBack cbRealDataCallBack, void* pUser);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_RealPlayBySimple(char * pserverip, char *user, char *pass, fRealDataCallBack cbRealDataCallBack, int iStreamType, int  nVideoPort, int  bIsTcp, void *pUserData);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_StopRealPlay(long lRealHandle);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_StopAllRealPlay();

//设备音频和对讲
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_StartTalk(int connectType, int destAudiotype, int samplerate, int bitspersample, int channels);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_StopTalk();
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_AddTalk(long lUserID);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_RemoveTalk(long lUserID);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_StartVoiceCom(long lUserID);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_StopVoiceCom(long lUserID);

//音频采集（目前只支持windows系统）
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_StartAudioCapture(int samplerate, int bitspersample, int channels, fCaptureAudioCallBack cbCaptureAudioCallBack, void* pUser);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_StopAudioCapture();
//自定义对讲数据接口
//srcAudioType 输入的音频格式。
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_InputAudioData(int srcAudioType, unsigned char* pBuff, int len);

//获取和设置设备配置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GetDeviceAbility(long lUserID);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GetDeviceConfig(long lUserID, long dwCommand);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_SetDevcieConfig(long lUserID, long dwCommand, void* pInBuffer, long dwInBufferSize);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GetDVRConfig(long lUserID, long dwCommand);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_SystemControl(long lUserID, long nCmdValue, long flag, char * pXml);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_SetDVRConfig(long lUserID, long dwCommand, void* pXml, long dwInBufferSize);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_CreateIFrame(long lUserID, int bIsSubStream);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_RebootDVR(long lUserID);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_RestoreConfig(long lUserID);

//系统上传和下载文件（包括更新固件）
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_Upgrade(long lUserID, char *sFileName);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_SetConfigFile(long lUserID, char *sFileName);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GetUpgradeProgress(long lUserID);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GetUpgradeState(long lUserID);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_CloseUpgradeHandle(long lUserID);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GetFileByName(long lUserID, long nFileType, char *sDVRFileName, char *saveDir);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GetConfigFile(long lUserID, char *sFileName);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_StopGetFile(long lUserID);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GetDownloadState(long lUserID);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GetDownloadPos(long lUserID);
//云台控制
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_PTZControl(long lUserID, long dwPTZCommand, long nTspeed, long nSpeed);
//此接口支持485透传，支持自定义云台消息
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_PTZControlEx(long lUserID, char *pXml);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_PTZPreset(long lUserID, long dwPTZPresetCmd, long dwPresetIndex);
//格式化存储设备
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_FormatDisk(long lUserID, long lDiskNumber);
//设置和获取用户保存数据
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GetUserData(long lUserID, char * pOutBuffer, int* nInOutLen);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_SetUserData(long lUserID, char * pBuffer, int len);

//ipc文件回放
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_ControlPlay(long lUserID, int iReplayMode, long Action, long param);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_PlayDeviceByFile(long lUserID, char * filenme);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_PlayDeviceByTime(long lUserID, long lTimescamp);

//串口
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_SerialStart(long lUserID, SerialDataCallBack cbSDCallBack, void* pUser);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_SerialSend(long lUserID, long lChannel, char *pSendBuf);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_SerialStop(long lUserID);
//add by Alvin.Chen @20170310
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GetIOInPutStatus(long lUserID, int nChannelNo);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GetIOOutPutStatus(long lUserID, int nChannelNo);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_UploadOEMAppFile(long lUserID, char* filePath);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_UploadOEMCfgFile(long lUserID, char* filePath);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_UploadOEMMp3File(long lUserID, char* filePath);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_SearchOEMMp3File(long lUserID, int iPage);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_PlayMp3File(long lUserID, char* filePath, int nTimes);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_StopPlayMp3File(long lUserID);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GetPlayAudioStatus(long lUserID);

//获取设备配置新接口  细分获取配置，、
//请求成功后获取的配置将在辅助通道回调函数中得到
//辅助通道回调通过AJ_NETSDK_IPC_SetAUXResponseCallBack()设置 
//辅助通道回调中获得的配置信息是一串xml字符串 可以通过AJ_NETSDK_IPC_GetxxxByXml()接口解析转换得到相应的结构体
//流媒体配置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GET_MediaStreamConfig(long lUserID);
//媒体设置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GET_MediaConfig(long lUserID);
//视频配置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GET_VideoConfig(long lUserID);
//视频采集设置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GET_VideoCaptureConfig(long lUserID);
//视频编码设置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GET_VideoEncodeConfig(long lUserID);
//音频设置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GET_AudioConfig(long lUserID);
//音频采集配置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GET_AudioCaputreConfig(long lUserID);
//音频编码设置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GET_AudioEncodeConfig(long lUserID);
//告警配置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GET_AlarmConfig(long lUserID);
//移动侦测
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GET_MotionDetectAlarm(long lUserID);
//IO输入告警参数
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GET_InputAlarm(long lUserID);
//视频丢失告警参数
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GET_VideoLostAlarm(long lUserID);
//视频遮挡配置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GET_VideoCoverAlarm(long lUserID);
//存储满告警配置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GET_StorageFullAlarm(long lUserID);
//设备系统配置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GET_SystemConfig(long lUserID);
//云台配置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GET_PtzConfig(long lUserID);
//用户配置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GET_UserConfig(long lUserID);
//系统日志配置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GET_SyslogConfig(long lUserID);
//时区设置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GET_TimeConfig(long lUserID);
//设备系统语言设置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GET_MiscConfig(long lUserID);
//前端录像设置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GET_RecordConfig(long lUserID);
//osd设置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GET_VideoOSDConfig(long lUserID);
//平台设置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GET_PlatformConfig(long lUserID);
//28181配置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GET_GB28181Config(long lUserID);
//网络配置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GET_NetworkConfig(long lUserID);
//局域网配置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GET_NetworkLANConfig(long lUserID);
//wifi配置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GET_NetworkWIFIConfig(long lUserID);
//ADSL拔号配置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GET_NetworkADSLConfig(long lUserID);
//DDNS配置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GET_NetworkDDNSConfig(long lUserID);
//UPNP配置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GET_NetworkUPNPConfig(long lUserID);
//P2P设置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GET_NetworkP2PConfig(long lUserID);
//FTP&SMTP相关配置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GET_ServerConfig(long lUserID);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GET_FtpServerConfig(long lUserID);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GET_SmtpServerConfig(long lUserID);
//设置设备配置新接口  采用结构体不在使用Xml配置
//流媒体设置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_SET_MediaStreamConfig(long lUserID, MediaStreamConfig *pConfig);
//媒体设置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_SET_MediaConfig(long lUserID, MediaConfig *pConfig);
//视频配置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_SET_VideoConfig(long lUserID, VideoConfig *pConfig);
//视频采集设置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_SET_VideoCaptureConfig(long lUserID, VideoCapture *pConfig);
//视频编码设置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_SET_VideoEncodeConfig(long lUserID, VideoEncode *pConfig);
//OSD时间标题设置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_SET_VideoOSDConfig(long lUserID, VideoOverlay *pConfig);
//音频设置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_SET_AudioConfig(long lUserID, AudioConfig *pConfig);
//音频采集设置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_SET_AudioCaputreConfig(long lUserID, AudioCapture *pConfig);
//音频编码设置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_SET_AudioEncodeConfig(long lUserID, AudioEncode *pConfig);
//告警配置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_SET_AlarmConfig(long lUserID, AlarmConfig* pConfig);
//移动侦测
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_SET_MotionDetectAlarm(long lUserID, MotionDetectAlarm *pConfig);
//视频遮挡
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_SET_VideoCoverAlarm(long lUserID, VideoCoverAlarm *pConfig);
//隐私遮挡设置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_SET_VideoMaskConfig(long lUserID, VideoMaskConfig *pConfig);
//设备默认语言设置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_SET_MiscConfig(long lUserID, MiscConfig *pConfig);
//平台设置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_SET_PlatformConfig(long lUserID, PlatformConfig *pConfig);
//28181设置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_SET_GB28181Config(long lUserID, GB28181Config *pConfig);
//用户列表设置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_SET_UserConfig(long lUserID, UserConfig *pConfig);
//时间同步设置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_SET_TimeConfig(long lUserID, TimeConfig *pConfig);
//当时间同步为手动时设置设备时间
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_SET_TimeManualConfig(long lUserID, TimeManualConfg *pConfig);
//局域网设置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_SET_NetworkLANConfig(long lUserID, LANConfig *pConfig);
//Wifi设置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_SET_NetworkWIFIConfig(long lUserID, WIFIConfig *pConfig);
//网络配置
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_SET_NetworkConfig(long lUserID, NetworkConfigNew *pConfig);

/*
去XML，使用结构体来获取/设置
设置前，请确保数据正确，否则可能导致设备无法启动(最好先获取一遍，然后修改需要修改的项目)
*/

/*
从XML解析出结构体
*/
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GetNetworkCfgByXml(NetworkConfigNew *pNetworkCfg, char *xmlBuf);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_Network_getLANCfgByXml(LANConfig *lanCfg, char *xmlBuf);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_Network_getWIFICfgByXml(WIFIConfig *wifiCfg, char *xmlBuf);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_Network_getADSLCfgByXml(ADSLConfigNew *adslCfg, char *xmlBuf);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_Network_getDDNSCfgByXml(DDNSConfig *ddnsCfg, char *xmlBuf);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_Network_getUPNPCfgByXml(UPNPConfig *upnpCfg, char *xmlBuf);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_Network_getP2PCfgByXml(P2PConfig *p2pCfg, char *xmlBuf);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_Server_getFtpsByXml(ServerConfig *pServerCfg, char *xmlBuf);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_Server_getSmtpsByXml(ServerConfig *pServerCfg, char *xmlBuf);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GetServerCfgByXml(ServerConfig *pServerCfg, char *xmlBuf);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GetRecordCfgByXml(RecordConfig *pRecordCfg, char *xmlBuf);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_Media_getAudioByXml(AudioConfig *pAudioCfg, char *xmlBuf);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_Media_getVideoByXml(VideoConfig *pVideoCfg, char *xmlBuf);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GetMediaCfgByXml(MediaConfig *pMediaCfg, char *xmlBuf);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_Media_getVideoCaptureByXml(VideoCapture *pVideoCapture, char *xmlBuf);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_Media_getVideoOverlayByXml(VideoOverlay *pVideoOverlay, char *xmlBuf);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_Media_getVideoEncodeByXml(VideoEncode *pVideoEncode, char *xmlBuf);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_Media_getJpegEncodeByXml(JpegEncodeCfg *pJpegCfg, char *xmlBuf);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_Media_getVideoMaskByXml(VideoMaskConfig *pVideoMask, char *xmlBuf);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GetMediaStreamCfgByXml(MediaStreamConfig *pMediaStream, char *xmlBuf);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GetPlatformCfgByXml(PlatformConfig *pPlatform, char *xmlBuf);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GetGB28181CfgByXml(GB28181Config *pPlatformCfg, char *xmlBuf);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_Alarm_getInputByXml(InputAlarm *pInputAlm, char *xmlBuf);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_Alarm_getMotionDetectByXml(MotionDetectAlarm *pMDAlm, char *xmlBuf);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_Alarm_getVideoLostByXml(VideoLostAlarm *pVideoLost, char *xmlBuf);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_Alarm_getVideoCoverByXml(VideoCoverAlarm *pVideoCover, char *xmlBuf);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_Alarm_getStorageFullByXml(StorageFullAlarm *pSFAlm, char *xmlBuf);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GetAlarmConfigByXml(AlarmConfig *pAlarmCfg, char *xmlBuf);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_InputAlarm_getAlarmChannelCfgByXml(AlarmChannel *pAlarmChannel, char *xmlBuf);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_System_getPTZCfgByXml(PTZConfig *pPtzCfg, char *xmlBuf);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_System_getTimeCfgByXml(TimeConfig *pTimeCfg, char *xmlBuf);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_System_getUserCfgByXml(UserConfig *pUserCfg, char *xmlBuf);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_System_getLogCfgByXml(SyslogConfig *pSyslogCfg, char *xmlBuf);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_System_getMiscCfgByXml(MiscConfig *pMiscCfg, char *xmlBuf);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_GetSystemConfigByXml(SystemConfig *pSystemCfg, char *xmlBuf);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_System_getPTZCommonCfgByXml(PTZCommonConfig *pPtzCommonCfg, char *xmlBuf);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_System_getPTZAdvanceCfgByXml(PTZAdvanceConfig *pPtzAdvanceCfg, char *xmlBuf);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_Media_getAudioCaptureByXml(AudioCapture *pCaptureCfg, char *xmlBuf);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_Media_getAudioEncodeByXml(AudioEncode *pEncodeCfg, char *xmlBuf);
/*
将结构体转换成XML
XML内存为动态malloc ，用完后需要调用者手动free，否则会造成内存泄漏
释放内存必须使用AJ_NETSDK_IPC_XMLGET_SAFE_FREE 接口进行释放。
*/
LIB_NETSDK_API char* __stdcall AJ_NETSDK_IPC_XMLGET_SystemConfig(SystemConfig *pSystemCfg);
LIB_NETSDK_API char* __stdcall AJ_NETSDK_IPC_XMLGET_UserConfig(UserConfig *pUserCfg);
LIB_NETSDK_API char* __stdcall AJ_NETSDK_IPC_XMLGET_TimeConfig(TimeConfig *pTimeCfg);
LIB_NETSDK_API char* __stdcall AJ_NETSDK_IPC_XMLGET_SyslogConfig(SyslogConfig *pSyslogCfg);
LIB_NETSDK_API char* __stdcall AJ_NETSDK_IPC_XMLGET_SysMiscConfig(MiscConfig *pMiscCfg);
LIB_NETSDK_API char* __stdcall AJ_NETSDK_IPC_XMLGET_PTZConfig(PTZConfig *pPtzCfg);
LIB_NETSDK_API char* __stdcall AJ_NETSDK_IPC_XMLGET_AlarmConfig(AlarmConfig *pAlarmCfg);
LIB_NETSDK_API char* __stdcall AJ_NETSDK_IPC_XMLGET_InputAlarmConfig(InputAlarm *pInputAlm);
LIB_NETSDK_API char* __stdcall AJ_NETSDK_IPC_XMLGET_MDAlarmConfig(MotionDetectAlarm *pMDAlm);
LIB_NETSDK_API char* __stdcall AJ_NETSDK_IPC_XMLGET_VlAlarmConfig(VideoLostAlarm *pVideoLost);
LIB_NETSDK_API char* __stdcall AJ_NETSDK_IPC_XMLGET_VCAlarmConfig(VideoCoverAlarm *pVideoCover);
LIB_NETSDK_API char* __stdcall AJ_NETSDK_IPC_XMLGET_SFAlarmConfig(StorageFullAlarm *pSFAlm);
LIB_NETSDK_API char* __stdcall AJ_NETSDK_IPC_XMLGET_MediaStreamConfig(MediaStreamConfig *mediaStreamCfg);
LIB_NETSDK_API char* __stdcall AJ_NETSDK_IPC_XMLGET_PlatformConfig(PlatformConfig *platformCfg);
LIB_NETSDK_API char* __stdcall AJ_NETSDK_IPC_XMLGET_GB28181Config(GB28181Config *platformCfg);
LIB_NETSDK_API char* __stdcall AJ_NETSDK_IPC_XMLGET_RecordConfig(RecordConfig *recordCfg);
LIB_NETSDK_API char* __stdcall AJ_NETSDK_IPC_XMLGET_NetworkConfig(NetworkConfigNew *networkCfg);
LIB_NETSDK_API char* __stdcall AJ_NETSDK_IPC_XMLGET_NetworkLANConfig(LANConfig *lanCfg);
LIB_NETSDK_API char* __stdcall AJ_NETSDK_IPC_XMLGET_NetworkWIFIConfig(WIFIConfig *wifiCfg);
LIB_NETSDK_API char* __stdcall AJ_NETSDK_IPC_XMLGET_NetworkADSLConfig(ADSLConfigNew *adslCfg);
LIB_NETSDK_API char* __stdcall AJ_NETSDK_IPC_XMLGET_NetworkDDNSConfig(DDNSConfig *ddnsCfg);
LIB_NETSDK_API char* __stdcall AJ_NETSDK_IPC_XMLGET_NetworkUPNPConfig(UPNPConfig *upnpCfg);
LIB_NETSDK_API char* __stdcall AJ_NETSDK_IPC_XMLGET_NetworkP2PConfig(P2PConfig *pCfg);
LIB_NETSDK_API char* __stdcall AJ_NETSDK_IPC_XMLGET_ServerConfig(ServerConfig *serverCfg);
LIB_NETSDK_API char* __stdcall AJ_NETSDK_IPC_XMLGET_FtpConfig(FtpServerList *fptServerList);
LIB_NETSDK_API char* __stdcall AJ_NETSDK_IPC_XMLGET_SmtpConfig(SmtpServerList *smtpServerList);
LIB_NETSDK_API char* __stdcall AJ_NETSDK_IPC_XMLGET_MediaConfig(MediaConfig *mediaCfg);
LIB_NETSDK_API char* __stdcall AJ_NETSDK_IPC_XMLGET_AudioConfig(AudioConfig *audioCfg);
LIB_NETSDK_API char* __stdcall AJ_NETSDK_IPC_XMLGET_VideoConfig(VideoConfig *videoCfg);
LIB_NETSDK_API char* __stdcall AJ_NETSDK_IPC_XMLGET_VideoOverlayConfig(VideoOverlay *pCfg);
LIB_NETSDK_API char* __stdcall AJ_NETSDK_IPC_XMLGET_VideoMaskConfig(VideoMaskConfig *pCfg);
LIB_NETSDK_API char* __stdcall AJ_NETSDK_IPC_XMLGET_VideoCaptureConfig(VideoCapture*pCfg);
LIB_NETSDK_API char* __stdcall AJ_NETSDK_IPC_XMLGET_VideoEncodeConfig(VideoEncode*pCfg);
LIB_NETSDK_API char* __stdcall AJ_NETSDK_IPC_XMLGET_AudioCaptureConfig(AudioCapture* audioCfg);
LIB_NETSDK_API char* __stdcall AJ_NETSDK_IPC_XMLGET_AudioEncodeConfig(AudioEncode *audioCfg);
LIB_NETSDK_API long __stdcall AJ_NETSDK_IPC_XMLGET_SAFE_FREE(void* p);
#endif //LIBNETSDK_LIBNETSDK_H
