#include "StdAfx.h"
#include "DeviceBase.h"
#include "AjNetSdkDemo.h"
#include "AjNetSdkDemoDlg.h"
CDeviceBase::CDeviceBase(void)
{
	m_szLikeName.Empty();
	m_szGroup = _T("Default");
	m_hTreeItem = NULL;
	m_iUpgradeIndex = -1;
	m_iWillPlayIndex = -1;
	m_bSnapshot = TRUE;
	m_szImagePath.Empty();
	m_bOnLine = FALSE;
	m_bUpgrading = FALSE;
	m_bAudioOpen = FALSE;
	m_iPlayWndIndex = -1;
	m_iPlayStream = -1;
	m_iRecordType = -1;
	m_iRecordStream = -1;
	m_lReaderID = 0;
	m_iVoiceState = 0;
	m_dwLastAlarmTime = GetTickCount();
}


CDeviceBase::~CDeviceBase(void)
{
	m_szLikeName.Empty();
	m_szGroup = _T("Default");
	m_hTreeItem = NULL;
	m_iUpgradeIndex = -1;
	m_iWillPlayIndex = -1;
	m_bSnapshot = TRUE;
	m_szImagePath.Empty();
	m_bOnLine = FALSE;
	m_bUpgrading = FALSE;
	m_bAudioOpen = FALSE;
	m_iPlayWndIndex = -1;
	m_iPlayStream = -1;
	m_iRecordType = -1;
	m_iRecordStream = -1;
	m_lReaderID = 0;
	m_iVoiceState = 0;
	m_dwLastAlarmTime = GetTickCount();
}

void CDeviceBase::InitRecordThread()
{
}

void CDeviceBase::CloseRecordThread()
{
}

void CDeviceBase::ReflashTreeImage()
{
	CTreeCtrl* pTreeCtrl = ((CAjNetSdkDemoDlg*)theApp.m_pMainWnd)->GetDevictTree();
	if(!pTreeCtrl || !pTreeCtrl->GetSafeHwnd())			//бؼ
		return;
	if (m_hTreeItem)
	{
		if(m_bOnLine)		//豸
		{
			if (m_iPlayWndIndex == -1)
			{
				if (m_iRecordType == -1)
					pTreeCtrl->SetItemImage(m_hTreeItem, 3, 3);
				else
					pTreeCtrl->SetItemImage(m_hTreeItem, 6, 6);
			}
			else
			{
				if (m_iRecordType == -1)
					pTreeCtrl->SetItemImage(m_hTreeItem, 7, 7);
				else
					pTreeCtrl->SetItemImage(m_hTreeItem, 10, 10);
			}
		}
		else
			pTreeCtrl->SetItemImage(m_hTreeItem, 2, 2);
	}
}

void CDeviceBase::SetDeviceOnlineState(BOOL bOnline)
{
	m_bOnLine = bOnline;
	ReflashTreeImage();
}

BOOL CDeviceBase::GetDeviceIsOnline()
{
	return m_bOnLine;
}

void CDeviceBase::SetDeviceSupportPtz(BOOL bPtz)
{
	m_bPtz = bPtz;
}

BOOL CDeviceBase::GetDeviceSupportPtz()
{
	return m_bPtz;
}

int CDeviceBase::GetPlayStream()
{
	if (m_iPlayWndIndex >= 0)
		return m_iPlayStream;
	else
		return -1;
}

int CDeviceBase::GetRecordType()
{
	return m_iRecordType;
}

int CDeviceBase::GetRecordStream()
{
	return m_iRecordStream;
}

int CDeviceBase::GetPlayWndIndex()
{
	return m_iPlayWndIndex;
}

int CDeviceBase::GetAudioState()
{
	return m_bAudioOpen;
}

int CDeviceBase::SetVoiceState(int iState)
{
	m_iVoiceState = iState;
	return 0;
}

int CDeviceBase::GetVoiceState()
{
	return m_iVoiceState;
}